/**
 * Copyright (C) 2009-2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_WINDOW_H
#define WK_WINDOW_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

typedef enum
{
    WK_WINDOW_TYPE_MAIN = 0,
    WK_WINDOW_TYPE_CHILD
} WkWindowType;

typedef struct _WkWindowPrivate WkWindowPrivate;
typedef struct _WkWindowClass   WkWindowClass;
typedef struct _WkWindow        WkWindow;

#define WK_TYPE_WINDOW             (wk_window_get_type ())
#define WK_WINDOW(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), WK_TYPE_WINDOW, WkWindow))
#define WK_WINDOW_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), WK_TYPE_WINDOW, WkWindowClass))
#define WK_IS_WINDOW(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WK_TYPE_WINDOW))
#define WK_IS_WINDOW_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), WK_TYPE_WINDOW))
#define WK_WINDOW_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), WK_TYPE_WINDOW, WkWindowClass))

struct _WkWindowClass
{
    GtkWindowClass __parent__;

    void (*open)   (WkWindow *window);
    void (*close)  (WkWindow *window);
};

struct _WkWindow
{
    GtkWindow  __parent__;

    WkWindowPrivate *priv;
};

GType wk_window_get_type (void) G_GNUC_CONST G_GNUC_INTERNAL;

GtkWidget *wk_window_new (WkWindowType type,
                          gchar       *url);

GtkWidget *wk_window_get_view (WkWindow *window);

G_END_DECLS

#endif /* !WK_WINDOW_H */
